Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends

# Skype Class Reference

The main class that exposes Skype-related functionality to your application. Currently the SDK only supports one Skype class instance per runtime. Note that most of the Skype class methods will fail until you have successfully logged in with an account. For more information on constructing a Skype object and the login sequence, see first tutorial example.
. More...

`#include <skype-embedded_2.h>`

List of all members.

## Public Types
enum | IDENTITYTYPE { UNRECOGNIZED = 0, SKYPE, SKYPE_MYSELF, SKYPE_UNDISCLOSED, PSTN, PSTN_EMERGENCY, PSTN_FREE, PSTN_UNDISCLOSED, CONFERENCE, EXTERNAL }
enum | NORMALIZERESULT { IDENTITY_OK = 0, IDENTITY_EMPTY, IDENTITY_TOO_LONG, IDENTITY_CONTAINS_INVALID_CHAR, PSTN_NUMBER_TOO_SHORT, PSTN_NUMBER_HAS_INVALID_PREFIX, SKYPENAME_STARTS_WITH_NONALPHA, SKYPENAME_SHORTER_THAN_6_CHARS }
enum | PREPARESOUNDRESULT { PREPARESOUND_SUCCESS = 0, PREPARESOUND_MISC_ERROR, PREPARESOUND_FILE_NOT_FOUND, PREPARESOUND_FILE_TOO_BIG, PREPARESOUND_FILE_READ_ERROR, PREPARESOUND_UNSUPPORTED_FILE_FORMAT, PREPARESOUND_PLAYBACK_NOT_SUPPORTED }
enum | AUDIODEVICE_CAPABILITIES { HAS_VIDEO_CAPTURE = 1, HAS_USB_INTERFACE, POSSIBLY_HEADSET = 4, HAS_AUDIO_CAPTURE = 8, HAS_AUDIO_RENDERING = 16, HAS_LOWBANDWIDTH_CAPTURE = 32, IS_WEBCAM = 64, IS_HEADSET = 128, POSSIBLY_WEBCAM = 256, HAS_VIDEO_RENDERING = 2048, HAS_BLUETOOTH_INTERFACE = 4096 }
enum | OPERATING_MEDIA { OM_UNKNOWN = 0, OM_FREE, OM_FREE_WIRELESS, OM_3G, OM_4G }
enum | VALIDATERESULT { NOT_VALIDATED = 0, VALIDATED_OK, TOO_SHORT, TOO_LONG, CONTAINS_INVALID_CHAR, CONTAINS_SPACE, SAME_AS_USERNAME, INVALID_FORMAT, CONTAINS_INVALID_WORD, TOO_SIMPLE, STARTS_WITH_INVALID_CHAR }
enum | PROXYTYPE { HTTPS_PROXY = 0, SOCKS_PROXY }
enum | APP2APP_STREAMS { ALL_STREAMS = 0, SENDING_STREAMS, RECEIVED_STREAMS }
## Public Member Functions
| Skype (int num_threads=1)
virtual | ~Skype ()
bool | start ()
const unsigned int | moduleID () const
String | getNamespace () const
const PMAP * | getPMap () const
const EMAP * | getEMap () const
Sid::Field * | get_property_desc (const uint &modid, const uint &propid)
SEObject * | factory (const uint &modid, const uint &oid)
void * | prop_factory (const uint &moduleid)
Sid::List_uint * | prop_cached_list (void *propstruct, const uint &moduleid)
Sid::Protocol::Status | dispatch_event (Sid::CommandInitiator *thread, Sid::Protocol::ClientInterface *protocol, const uint &modid, const uint &evid)
bool | Start (bool &started)
bool | GetVersionString (Sid::String &version)
bool | GetHardwiredContactGroup (const ContactGroup::TYPE &type, ContactGroupRef &contactGroup)
bool | GetCustomContactGroups (ContactGroupRefs &groups)
bool | CreateCustomContactGroup (ContactGroupRef &group)
virtual void | OnNewCustomContactGroup (const ContactGroupRef &group)
bool | GetContactType (const Sid::String &identity, Contact::TYPE &type)
bool | GetContact (const Sid::String &identity, ContactRef &contact)
bool | FindContactByPstnNumber (const Sid::String &number, bool &found, ContactRef &contact, uint &foundInKey)
bool | GetIdentityType (const Sid::String &identity, IDENTITYTYPE &type)
bool | IdentitiesMatch (const Sid::String &identityA, const Sid::String &identityB, bool &result)
bool | NormalizeIdentity (const Sid::String &original, NORMALIZERESULT &result, Sid::String &normalized, const bool isNewSkypeName=false)
bool | NormalizePSTNWithCountry (const Sid::String &original, NORMALIZERESULT &result, Sid::String &normalized, const uint countryPrefix=0)
virtual void | OnContactOnlineAppearance (const ContactRef &contact)
virtual void | OnContactGoneOffline (const ContactRef &contact)
bool | GetOptimalAgeRanges (Sid::List_uint &rangeList)
bool | CreateContactSearch (ContactSearchRef &search)
bool | CreateBasicContactSearch (const Sid::String &text, ContactSearchRef &search)
bool | CreateIdentitySearch (const Sid::String &identity, ContactSearchRef &search)
bool | CreateConference (ConversationRef &conference)
bool | GetConversationByIdentity (const Sid::String &convoIdentity, ConversationRef &conversation)
bool | GetConversationByParticipants (const Sid::List_String &participantIdentities, ConversationRef &conversation, const bool createIfNonExisting=false, const bool ignoreBookmarkedOrNamed=false)
bool | GetConversationByBlob (const Sid::String &joinBlob, ConversationRef &conversation, const bool alsoJoin=true)
bool | GetConversationList (ConversationRefs &conversations, const Conversation::LIST_TYPE type=Conversation::ALL_CONVERSATIONS)
virtual void | OnConversationListChange (const ConversationRef &conversation, const Conversation::LIST_TYPE &type, const bool &added)
bool | GetMessageByGuid (const Sid::Binary &guid, MessageRef &message)
bool | GetMessageListByType (const Message::TYPE &type, const bool &latestPerConvOnly, MessageRefs &messages, const uint fromTimestampInc=0, const uint toTimestampExc=MAX_UINT)
virtual void | OnMessage (const MessageRef &message, const bool &changesInboxTimestamp, const MessageRef &supersedesHistoryMessage, const ConversationRef &conversation)
bool | GetAvailableVideoDevices (Sid::List_String &deviceNames, Sid::List_String &devicePaths, uint &count)
bool | HasVideoDeviceCapability (const Sid::String &deviceName, const Sid::String &devicePath, const Video::VIDEO_DEVICE_CAPABILITY &cap)
bool | DisplayVideoDeviceTuningDialog (const Sid::String &deviceName, const Sid::String &devicePath)
bool | GetPreviewVideo (const Video::MEDIATYPE &type, VideoRef &video, const Sid::String deviceName="", const Sid::String devicePath="")
bool | VideoCommand (const Sid::String &command, Sid::String &response)
virtual void | OnAvailableVideoDeviceListChange ()
bool | GetGreeting (const Sid::String &skypeName, VoicemailRef &greeting)
bool | PlayStart (const uint &soundid, const Sid::Binary &sound, const bool &loop, const bool useCallOutDevice=false)
bool | PlayStartFromFile (const uint &soundid, const Sid::Filename &datafile, const bool &loop, PREPARESOUNDRESULT &result, const bool useCallOutDevice=false)
bool | PlayStop (const uint &soundid)
bool | StartRecordingTest (const bool recordAndPlaybackData=false)
bool | StopRecordingTest ()
bool | GetAvailableOutputDevices (Sid::List_String &handleList, Sid::List_String &nameList, Sid::List_String &productIdList)
bool | GetAvailableRecordingDevices (Sid::List_String &handleList, Sid::List_String &nameList, Sid::List_String &productIdList)
bool | SelectSoundDevices (const Sid::String &callInDevice, const Sid::String &callOutDevice, const Sid::String &waveOutDevice)
bool | GetAudioDeviceCapabilities (const Sid::String &deviceHandle, Sid::String &interfaceString, uint &capabilities)
bool | GetNrgLevels (uint &micLevel, uint &speakerLevel)
bool | VoiceCommand (const Sid::String &command, Sid::String &response)
bool | GetSpeakerVolume (uint &volume)
bool | SetSpeakerVolume (const uint &volume)
bool | GetMicVolume (uint &micVolume)
bool | SetMicVolume (const uint &volume)
bool | IsSpeakerMuted (bool &muted)
bool | IsMicrophoneMuted (bool &muted)
bool | MuteSpeakers (const bool &mute)
bool | MuteMicrophone (const bool &mute)
virtual void | OnAvailableDeviceListChange ()
virtual void | OnNrgLevelsChange ()
bool | SetOperatingMedia (const OPERATING_MEDIA &media, const uint &maxUplinkBps, const uint &maxDownlinkBps)
bool | RequestConfirmationCode (const Sms::CONFIRM_TYPE &type, const Sid::String &number, SmsRef &sms)
bool | SubmitConfirmationCode (const Sid::String &number, const Sid::String &code, SmsRef &sms)
bool | CreateOutgoingSms (SmsRef &sms)
bool | GetAccount (const Sid::String &identity, AccountRef &account)
bool | GetExistingAccounts (Sid::List_String &accountNameList)
bool | GetDefaultAccountName (Sid::String &account)
bool | GetSuggestedSkypename (const Sid::String &fullname, Sid::String &suggestedName)
bool | ValidateAvatar (const Sid::Binary &value, VALIDATERESULT &result, int &freeBytesLeft)
bool | ValidateProfileString (const int &propKey, const Sid::String &strValue, VALIDATERESULT &result, int &freeBytesLeft, const bool forRegistration=false)
bool | ValidatePassword (const Sid::String &username, const Sid::String &password, VALIDATERESULT &result)
virtual void | OnProxyAuthFailure (const PROXYTYPE &type)
bool | GetStr (const Sid::String &key, Sid::String &value)
bool | GetInt (const Sid::String &key, int &value)
bool | GetBin (const Sid::String &key, Sid::Binary &value)
bool | SetStr (const Sid::String &key, const Sid::String &value)
bool | SetInt (const Sid::String &key, const int &value)
bool | SetBin (const Sid::String &key, const Sid::Binary &value)
bool | IsDefined (const Sid::String &key, bool &value)
bool | Delete (const Sid::String &key)
bool | GetSubKeys (const Sid::String &key, Sid::List_String &value)
bool | GetISOLanguageInfo (Sid::List_String &languageCodeList, Sid::List_String &languageNameList)
bool | GetISOCountryInfo (Sid::List_String &countryCodeList, Sid::List_String &countryNameList, Sid::List_uint &countryPrefixList, Sid::List_String &countryDialExampleList)
bool | GetISOCountryCodebyPhoneNo (const Sid::String &number, Sid::String &countryCode)
bool | App2AppCreate (const Sid::String &appname, bool &result)
bool | App2AppDelete (const Sid::String &appname, bool &result)
bool | App2AppConnect (const Sid::String &appname, const Sid::String &skypename, bool &result)
bool | App2AppDisconnect (const Sid::String &appname, const Sid::String &stream, bool &result)
bool | App2AppWrite (const Sid::String &appname, const Sid::String &stream, const Sid::Binary &data, bool &result)
bool | App2AppDatagram (const Sid::String &appname, const Sid::String &stream, const Sid::Binary &data, bool &result)
bool | App2AppRead (const Sid::String &appname, const Sid::String &stream, bool &result, Sid::Binary &data)
bool | App2AppGetConnectableUsers (const Sid::String &appname, bool &result, Sid::List_String &users)
bool | App2AppGetStreamsList (const Sid::String &appname, const APP2APP_STREAMS &listType, bool &result, Sid::List_String &streams, Sid::List_uint &receivedSizes)
virtual void | OnApp2AppDatagram (const Sid::String &appname, const Sid::String &stream, const Sid::Binary &data)
virtual void | OnApp2AppStreamListChange (const Sid::String &appname, const APP2APP_STREAMS &listType, const Sid::List_String &streams, const Sid::List_uint &receivedSizes)
## Static Public Member Functions
static Skype * | instance ()
## Protected Member Functions
virtual ContactGroup * | newContactGroup (int oid)
virtual Contact * | newContact (int oid)
virtual ContactSearch * | newContactSearch (int oid)
virtual Participant * | newParticipant (int oid)
virtual Conversation * | newConversation (int oid)
virtual Message * | newMessage (int oid)
virtual Video * | newVideo (int oid)
virtual Voicemail * | newVoicemail (int oid)
virtual Sms * | newSms (int oid)
virtual Transfer * | newTransfer (int oid)
virtual Account * | newAccount (int oid)
## Friends
class | SEObject
class | ContactGroup
class | Contact
class | ContactSearch
class | Participant
class | Conversation
class | Message
class | Video
class | Voicemail
class | Sms
class | Transfer
class | Account

## Detailed Description

The main class that exposes Skype-related functionality to your application. Currently the SDK only supports one Skype class instance per runtime. Note that most of the Skype class methods will fail until you have successfully logged in with an account. For more information on constructing a Skype object and the login sequence, see first tutorial example.
.

Examples:

  tutorial_1.cpp, tutorial_10.cpp, tutorial_11.cpp, tutorial_12.cpp, tutorial_13.cpp, tutorial_14.cpp, tutorial_15.cpp, tutorial_16.cpp, tutorial_2.cpp, tutorial_3.cpp, tutorial_4.cpp, tutorial_5.cpp, tutorial_6.cpp, tutorial_7.cpp, tutorial_8.cpp, and tutorial_9.cpp.

Definition at line 3040 of file skype-embedded_2.h.

## Member Enumeration Documentation

enum Skype::APP2APP_STREAMS

Enumerator:

  ALL_STREAMS |
  SENDING_STREAMS |
  RECEIVED_STREAMS |

Definition at line 3778 of file skype-embedded_2.h.

enum Skype::AUDIODEVICE_CAPABILITIES

Enumerator:

  HAS_VIDEO_CAPTURE |
  HAS_USB_INTERFACE |
  POSSIBLY_HEADSET |
  HAS_AUDIO_CAPTURE |
  HAS_AUDIO_RENDERING |
  HAS_LOWBANDWIDTH_CAPTURE |
  IS_WEBCAM |
  IS_HEADSET |
  POSSIBLY_WEBCAM |
  HAS_VIDEO_RENDERING |
  HAS_BLUETOOTH_INTERFACE |

Definition at line 3368 of file skype-embedded_2.h.

enum Skype::IDENTITYTYPE

Enumerator:

  UNRECOGNIZED |
  SKYPE |
  SKYPE_MYSELF |
  SKYPE_UNDISCLOSED |
  PSTN |
  PSTN_EMERGENCY |
  PSTN_FREE |
  PSTN_UNDISCLOSED |
  CONFERENCE |
  EXTERNAL |

Definition at line 3139 of file skype-embedded_2.h.

enum Skype::NORMALIZERESULT

Enumerator:

  IDENTITY_OK |
  IDENTITY_EMPTY |
  IDENTITY_TOO_LONG |
  IDENTITY_CONTAINS_INVALID_CHAR |
  PSTN_NUMBER_TOO_SHORT |
  PSTN_NUMBER_HAS_INVALID_PREFIX | identity looks like pstn number but does not start with +/00/011
  SKYPENAME_STARTS_WITH_NONALPHA |
  SKYPENAME_SHORTER_THAN_6_CHARS | returned only when isNewSkypeName

Definition at line 3158 of file skype-embedded_2.h.

enum Skype::OPERATING_MEDIA

Enumerator:

  OM_UNKNOWN |
  OM_FREE |
  OM_FREE_WIRELESS |
  OM_3G |
  OM_4G |

Definition at line 3498 of file skype-embedded_2.h.

enum Skype::PREPARESOUNDRESULT

Enumerator:

  PREPARESOUND_SUCCESS |
  PREPARESOUND_MISC_ERROR |
  PREPARESOUND_FILE_NOT_FOUND |
  PREPARESOUND_FILE_TOO_BIG |
  PREPARESOUND_FILE_READ_ERROR |
  PREPARESOUND_UNSUPPORTED_FILE_FORMAT |
  PREPARESOUND_PLAYBACK_NOT_SUPPORTED |

Definition at line 3358 of file skype-embedded_2.h.

enum Skype::PROXYTYPE

Enumerator:

  HTTPS_PROXY |
  SOCKS_PROXY |

Definition at line 3641 of file skype-embedded_2.h.

enum Skype::VALIDATERESULT

A value of this type can be returned by one of the following methods (of Skype class): ValidateAvatar, ValidateProfileString, ValidatePassword.

Enumerator:

  NOT_VALIDATED | Given property could not be validated. The length of the field was within limits and the value is assumed to be Ok. Your client should treat this value as equivalent to VALIDATED_OK.
  VALIDATED_OK | Avatar or profile string validation succeeded.
  TOO_SHORT | Password is too short.
  TOO_LONG | The value exceeds max size limit for the given property.
  CONTAINS_INVALID_CHAR | Value contains illegal characters.
  CONTAINS_SPACE | Value contains whitespace.
  SAME_AS_USERNAME | Password cannot be the same as skypename.
  INVALID_FORMAT | Value has invalid format.
  CONTAINS_INVALID_WORD | Value contains invalid word.
  TOO_SIMPLE | Password is too simple.
  STARTS_WITH_INVALID_CHAR | Value starts with an invalid character.

Definition at line 3569 of file skype-embedded_2.h.

## Constructor & Destructor Documentation

Skype::Skype | ( | int | num_threads = `1` | ) |

Definition at line 2 of file skype-embedded_2.cpp.

Skype::~Skype | ( |  | ) | `[virtual]`

Definition at line 3 of file skype-embedded_2.cpp.

## Member Function Documentation

bool Skype::App2AppConnect | ( | const Sid::String & | appname,
|  | const Sid::String & | skypename,
|  | bool & | result |
| ) |  |  |

The App2AppConnect connect result does not mean the connection was immediately established. It will return Ok even if the remote party was offline. The actual connection will be established when both parties have fired App2AppConnect with the same application name, at eachother. At that point, OnApp2AppStreamListChange event will fire for both local and remote party (with listType argument set to ALL_STREAMS) and you can start exchanging data, using either App2App datagrams or App2AppRead App2AppWrite methods.

Parameters:

  | appname | Application ID. This needs to match with application ID connecting from the remote side.
  | skypename | Skype Name of the remote party.
  | result | NB! This argument will return true even if the remote party has not yet connected (or is not even online yet) - it merely indicates that the connect command was successfuly processed in runtime. The actual connection success will be indicated when the OnApp2AppStreamListChange event fires, i.e. when App2App stream will be established between connecting parties.

bool Skype::App2AppCreate | ( | const Sid::String & | appname,
|  | bool & | result |
| ) |  |  |

App2AppCreate method constructs a local instance of an App2App application. App2App applications are not abstracted in the SkypeKit API as a separate class. Rather, they can be created with App2AppCreate, supplying their name as ID, and then connected to remote parties using App2AppConnect method.
App2App portion of the SkypeKit API enables you to implement arbitrary data exchange protocols between Skype clients. Basically, if you are ever tempted to use conversation chat messages for something other than actual human-readable chat - you should consider using your own custom App2App protocol instead.
The downside of App2App is that all the participants need to be running a client that supports the same App2App application. Although, it is possible to have one side using a custom SkypeKit client and another side using Skype desktop client - App2App is supported in both, in case of desktop client via Public API - you are still limited to remote side running something that can recognize your protocol and react to connection attempts from your side.
To establish connection between each other, all participants need to create their local instances of the application (with the same ID, and then connect to each other. More than one App2App applications can be active in a local client at the same time. Also, more than two clients can be connected with the same application.
Once connection is established, you can choose between two communication methods - datagrams and stream read/write methods. Overall, there are not much principal difference between the two. Datagram packet size is limited to 1500 bytes and stream packet size to 32 KB of payload data. Implementation-wise, datagrams are probably somewhat easier to deal with.

Parameters:

  | appname | Application ID. This ID is used by the rest of the App2App commands to differentiate between applications, should there be more than one app2app applications running on the local system.
  | result | Returns true if the app creation was successful. Returns false when an application with the same name already exists in the local system.

bool Skype::App2AppDatagram | ( | const Sid::String & | appname,
|  | const Sid::String & | stream,
|  | const Sid::Binary & | data,
|  | bool & | result |
| ) |  |  |

Sends a datagram to the remote party specified in the stream argument. The max size of datagram payload is 1500 bytes.

Parameters:

  | appname | application ID - from App2AppCreate
  | stream | stream ID - either from App2AppGetStreamsList or from OnApp2AppStreamListChange
  | data | datagram payload (max 1500 bytes)
  | result | returns true on method success. Note that this does mean the remote party has actually received your datagram - that sort of feedback, should you want it, is up to you to implement in your custom protocol.

bool Skype::App2AppDelete | ( | const Sid::String & | appname,
|  | bool & | result |
| ) |  |  |

Disconnects and deletes the App2App application.

Parameters:

  | appname | application ID.
  | result | Returns true if the deletion was successful (application with such ID actually existed)

bool Skype::App2AppDisconnect | ( | const Sid::String & | appname,
|  | const Sid::String & | stream,
|  | bool & | result |
| ) |  |  |

Disconnects an App2App stream. This is different from App2AppDelete command in that it enables you to disconnect remote parties selectively - in case there are more than two participants in the App2App stream pool.

Parameters:

  | appname | application ID
  | stream | stream ID.
  | result | returns true when the stream disconnect was successful.

bool Skype::App2AppGetConnectableUsers | ( | const Sid::String & | appname,
|  | bool & | result,
|  | Sid::List_String & | users |
| ) |  |  |

App2AppGetConnectableUsers returns a list of currently online contacts. It does not return a list of contacts who have an app2app application running. There is currently no way of querying whether an application has been launched on the remote side - other than trying to connect to the remote side and waiting for timeout. NB! if you use App2AppGetConnectableUsers immediately after login - then the online presence of your contact list has not yet updated itself - so this method will most likely return either an empty list or a list with echo123 in it.

Parameters:

  | appname | application ID
  | result | returns true on method success
  | users | stringlist with Skype Names of connectable users

bool Skype::App2AppGetStreamsList | ( | const Sid::String & | appname,
|  | const APP2APP_STREAMS & | listType,
|  | bool & | result,
|  | Sid::List_String & | streams,
|  | Sid::List_uint & | receivedSizes |
| ) |  |  |

Takes application ID and list type filter and returns a stringlist with streamID's that pass the filter.

Parameters:

  | appname | application ID
  | listType | list type filter
  | result | results true if the method call was successful
  | streams | string list with stream IDs
  | receivedSizes | For RECEIVED_STREAMS, contains the number of bytes in each stream waiting to be read

bool Skype::App2AppRead | ( | const Sid::String & | appname,
|  | const Sid::String & | stream,
|  | bool & | result,
|  | Sid::Binary & | data |
| ) |  |  |

Reads data from the specified stream. This method should be called from the OnApp2AppStreamListChange event callback, when this callback gets fired with listType argument set to RECEIVED_STREAMS.

Parameters:

  | appname | application ID
  | stream | stream ID
  | result | returns true on method success. Note that this does mean the remote party has actually received your packet - that sort of feedback, should you want it, is up to you to implement in your custom protocol.
  | data | stream packet payload

bool Skype::App2AppWrite | ( | const Sid::String & | appname,
|  | const Sid::String & | stream,
|  | const Sid::Binary & | data,
|  | bool & | result |
| ) |  |  |

Sends a stream packet to the remote party specified in the stream argument. The max size of stream write packet is 32KB. After calling this method, OnApp2AppStreamListChange will fire for both parties. In local ssytem with listType set to SENDING_STREAMS and on remote system with listType set to RECEIVED_STREAMS. This event can be used to read received packets out of the stream.

Parameters:

  | appname | application ID
  | stream | stream ID
  | data | packet payload
  | result | returns true if the call was successful. Note that this does indicate the packet was actually received by remote party.

bool Skype::CreateBasicContactSearch | ( | const Sid::String & | text,
|  | ContactSearchRef & | search |
| ) |  |  |

searches skypenames, aliases, fullnames, emails. false if not valid

bool Skype::CreateConference | ( | ConversationRef & | conference | ) |

Creates a new empty conversation object and returns a reference to it.

bool Skype::CreateContactSearch | ( | ContactSearchRef & | search | ) |

Creates a blank contact search object, in which you can add your custom search terms. For more information how asynchronous contact search works, see ContactSearch class details.

Parameters:

  | search | Returns blank ContactSearch object.

bool Skype::CreateCustomContactGroup | ( | ContactGroupRef & | group | ) |

Creates a new empty contact group object and returns a reference to it. The group will then show up in the custom group list that you can get with Skype class GetCustomContactGroups method. Existing contacts can be added to the new group with ContactGroup class AddContact method and a custom name can be given to it with GiveDisplayName method.
Note that no check is made for existing of displaynames with the same name - if you wish to force uniqueness in custom group names you will have to check that yourself before creating the group.

bool Skype::CreateIdentitySearch | ( | const Sid::String & | identity,
|  | ContactSearchRef & | search |
| ) |  |  |

searches skypenames and aliases. returns 0 or 1 results. false if not valid

bool Skype::CreateOutgoingSms | ( | SmsRef & | sms | ) |

creates an OUTGOING/COMPOSING SMS message

bool Skype::Delete | ( | const Sid::String & | key | ) |

Sid::Protocol::Status Skype::dispatch_event | ( | Sid::CommandInitiator * | thread,
|  | Sid::Protocol::ClientInterface * | protocol,
|  | const uint & | modid,
|  | const uint & | evid |
| ) |  |  |

bool Skype::DisplayVideoDeviceTuningDialog | ( | const Sid::String & | deviceName,
|  | const Sid::String & | devicePath |
| ) |  |  |

SEObject * Skype::factory | ( | const uint & | modid,
|  | const uint & | oid |
| ) |  |  |

Definition at line 1909 of file skype-embedded_2.cpp.

References Account::MODULE_ID, Transfer::MODULE_ID, Sms::MODULE_ID, Voicemail::MODULE_ID, Video::MODULE_ID, Message::MODULE_ID, Conversation::MODULE_ID, Participant::MODULE_ID, ContactSearch::MODULE_ID, Contact::MODULE_ID, ContactGroup::MODULE_ID, newAccount(), newContact(), newContactGroup(), newContactSearch(), newConversation(), newMessage(), newParticipant(), newSms(), newTransfer(), newVideo(), newVoicemail(), and SEObject.

bool Skype::FindContactByPstnNumber | ( | const Sid::String & | number,
|  | bool & | found,
|  | ContactRef & | contact,
|  | uint & | foundInKey |
| ) |  |  |

Parameters:

  | foundInKey | type is actually PROPKEY

Sid::Field* Skype::get_property_desc | ( | const uint & | modid,
|  | const uint & | propid |
| ) |  |  |

bool Skype::GetAccount | ( | const Sid::String & | identity,
|  | AccountRef & | account |
| ) |  |  |

Retrieves an Account object by Skype name (identity). This should normally be one of the first method calls after Skype object initialization. Nearly all the other methods require successful account login in order to work properly. The list of accounts that have been used on the local machine/database can be retrieved with Skype::GetExistingAccounts method. If a matching identity is not found, a new Account object is created. This object can then be used to populate requred fields and then use Account::Register method for new account creation. This method returns false on error.

Parameters:

  | identity | Account skypename.
  | account | Returns account object if successful.

bool Skype::GetAudioDeviceCapabilities | ( | const Sid::String & | deviceHandle,
|  | Sid::String & | interfaceString,
|  | uint & | capabilities |
| ) |  |  |

The uint argument returns AUDIODEVICE_CAPABILITIES (declared in Skype class)

Parameters:

  | capabilities | bit set of AUDIODEVICE_CAPABILITIES

bool Skype::GetAvailableOutputDevices | ( | Sid::List_String & | handleList,
|  | Sid::List_String & | nameList,
|  | Sid::List_String & | productIdList |
| ) |  |  |

This method returns a table in form of three string lists of equal lengths. The first list contains audio output device handles ('hw:0,0', 'hw:0,1', etc.) The second list contains descriptive names of those devices (Ensoniq AudioPCI etc.) The third list contains device product IDs. Note that the values in these lists depend on which audio engine you are running (SAL, PCM, RTP).

bool Skype::GetAvailableRecordingDevices | ( | Sid::List_String & | handleList,
|  | Sid::List_String & | nameList,
|  | Sid::List_String & | productIdList |
| ) |  |  |

This method returns a table in form of three string lists of equal length. The first list contains audio recording device handles ('hw:0,0', 'hw:0,1', etc.) The second list contains descriptive names of those devices (Ensoniq AudioPCI etc.) The third list contains device product IDs. Note that the values in these lists depend on which audio engine you are running (SAL, PCM, RTP).

bool Skype::GetAvailableVideoDevices | ( | Sid::List_String & | deviceNames,
|  | Sid::List_String & | devicePaths,
|  | uint & | count |
| ) |  |  |

This method returns a table in form of two string lists of equal length and an uint argument that returns the count of items i both lists. The first list contains video recording device handles and the second list descriptive names of those devices. NB! This method requires videortphost to be running, otherwise it will return empty lists.

bool Skype::GetBin | ( | const Sid::String & | key,
|  | Sid::Binary & | value |
| ) |  |  |

This is used for retrieving local setup keys of type binary. For more information, see Defines section in the skype-embedded_2.h

bool Skype::GetContact | ( | const Sid::String & | identity,
|  | ContactRef & | contact |
| ) |  |  |

Returns a Contact object reference. If a matching contact is not found in the existing contact list, a new Contact object will be created. Note that if you pass in a phone number in the identity argument, the type for the newly created Contact will be automatically set to Contact::PSTN (Contact::SKYPE otherwise).

Parameters:

  | identity | Either skypename or a phone number
  | contact | Returns a contact object.

bool Skype::GetContactType | ( | const Sid::String & | identity,
|  | Contact::TYPE & | type |
| ) |  |  |

analyzes the identity for contact type

bool Skype::GetConversationByBlob | ( | const Sid::String & | joinBlob,
|  | ConversationRef & | conversation,
|  | const bool | alsoJoin = `true` |
| ) |  |  |

Retrieves a Conversation object by Public Conversation BLOB. Public conversation blobs are globally unique conversation IDs that provide a method for joining conversation without explicitly being added to the conversation by someone already in it. Programmatically, a Conversation BLOB can be retrieved with Conversation::GetJoinBlob method. In Skype desktop clients, the BLOB can be retrieved by typing "/get uri" in a conversation. The conversation can then be joined by people who have somehow received that BLOB.

Parameters:

  | joinBlob | The BLOB string.
  | conversation | Returns Conversation object if successful.
  | alsoJoin | If set to true, automatically joins current user into the Conversation.

bool Skype::GetConversationByIdentity | ( | const Sid::String & | convoIdentity,
|  | ConversationRef & | conversation |
| ) |  |  |

Returns reference tp conversation object by conversation ID string (equivalent of old chat ID). NB! ID here is that of conversation, rather than skypename of dialog partner. If you want to retrieve a conversation object with any particular person, then Skype class GetConversationByParticipants method is what you are looking for.

bool Skype::GetConversationByParticipants | ( | const Sid::List_String & | participantIdentities,
|  | ConversationRef & | conversation,
|  | const bool | createIfNonExisting = `false`,
|  | const bool | ignoreBookmarkedOrNamed = `false` |
| ) |  |  |

myself not included

bool Skype::GetConversationList | ( | ConversationRefs & | conversations,
|  | const Conversation::LIST_TYPE | type = `Conversation::ALL_CONVERSATIONS` |
| ) |  |  |

Returns a list of Conversation objects by Conversation::LIST_TYPE filter.

Parameters:

  | conversations | List of conversations matching the filter.
  | type | Filter.

bool Skype::GetCustomContactGroups | ( | ContactGroupRefs & | groups | ) |

Returns a list of custom contact group references, i.e. all contact groups that are not hardwired.

bool Skype::GetDefaultAccountName | ( | Sid::String & | account | ) |

return most recently used account that has pwd saved. empty string if none

const EMAP* Skype::getEMap | ( |  | ) | const`[inline]`

Definition at line 3075 of file skype-embedded_2.h.

bool Skype::GetExistingAccounts | ( | Sid::List_String & | accountNameList | ) |

Returns a list of possible profiles used before on this machine

bool Skype::GetGreeting | ( | const Sid::String & | skypeName,
|  | VoicemailRef & | greeting |
| ) |  |  |

bool Skype::GetHardwiredContactGroup | ( | const ContactGroup::TYPE & | type,
|  | ContactGroupRef & | contactGroup |
| ) |  |  |

Takes TYPE argument (TYPE comes from ContactGroup class) and returns reference to the corresponding hardwired contact group. For example (C++): skype->GetHardwiredContactGroup(ContactGroup::ONLINE_BUDDIES, GroupRef) would return the list of all contacts that are currently online.

bool Skype::GetIdentityType | ( | const Sid::String & | identity,
|  | IDENTITYTYPE & | type |
| ) |  |  |

This takes skypename or a phone number string as argument and returns corresponding identity type (SKYPE, SKYPE_MYSELF, PSTN, etc.)

bool Skype::GetInt | ( | const Sid::String & | key,
|  | int & | value |
| ) |  |  |

This is used for retrieving local setup keys of type int. For more information, see Defines section in the skype-embedded_2.h

bool Skype::GetISOCountryCodebyPhoneNo | ( | const Sid::String & | number,
|  | Sid::String & | countryCode |
| ) |  |  |

Returns 2-letter country code based on PSTN number. The input argument has to be without + in from of it - '37212345678' will return 'ee' while '+37212345678' will return an empty string.

bool Skype::GetISOCountryInfo | ( | Sid::List_String & | countryCodeList,
|  | Sid::List_String & | countryNameList,
|  | Sid::List_uint & | countryPrefixList,
|  | Sid::List_String & | countryDialExampleList |
| ) |  |  |

Returns three string lists and one int array, containing 2-letter country code, country name, dialing prefix and example dial string (not available for all items). This method does currently return 0 for South Georgia and the South Sandwich Islands.

Parameters:

  | countryNameList | assumes UI has set correct language

bool Skype::GetISOLanguageInfo | ( | Sid::List_String & | languageCodeList,
|  | Sid::List_String & | languageNameList |
| ) |  |  |

Returns two string lists. First of them will contain list of two-letter language codes (ISO 639-1) The second list contains names of corresponding languages.

Parameters:

  | languageNameList | assumes UI has set correct language

bool Skype::GetMessageByGuid | ( | const Sid::Binary & | guid,
|  | MessageRef & | message |
| ) |  |  |

Retrieves a Message object by the P_GUID property (globally unique ID, same for all the participants of the conversation, in which this message occured).

Parameters:

  | guid | Globally unique ID of the message.
  | message | Returns a Message object if a match was found.

bool Skype::GetMessageListByType | ( | const Message::TYPE & | type,
|  | const bool & | latestPerConvOnly,
|  | MessageRefs & | messages,
|  | const uint | fromTimestampInc = `0`,
|  | const uint | toTimestampExc = `MAX_UINT` |
| ) |  |  |

Returns all messages of the given type, the most recent POSTED_EMOTE or POSTED_TEXT of each conversation.

Parameters:

  | type | Type of messages requested
  | latestPerConvOnly | Whether to return only the most recent message per conversation
  | fromTimestampInc | Starting timestamp for reqested range, inclusive
  | toTimestampExc | Ending timestamp for requested range, exclusive

bool Skype::GetMicVolume | ( | uint & | micVolume | ) |

Returns value of microphone volume setting (0..100). It will return the analog gain of audio device set by Skype AGC. For real-time microphone volume, use GetNrgLevels method or OnNrgLevelsChange callback (both are methods of Skype class).

String Skype::getNamespace | ( |  | ) | const`[inline]`

Definition at line 3073 of file skype-embedded_2.h.

References __EA, and SKYPE.

bool Skype::GetNrgLevels | ( | uint & | micLevel,
|  | uint & | speakerLevel |
| ) |  |  |

Returns current audio stream volume for both playback and microphone streams. Useful for displaying visual audio indicators in you UI. See also Skype class OnNrgLevelsChange callback that gets fired each time the these values are changed.

bool Skype::GetOptimalAgeRanges | ( | Sid::List_uint & | rangeList | ) |

list of (min,max) pairs

const PMAP* Skype::getPMap | ( |  | ) | const`[inline]`

Definition at line 3074 of file skype-embedded_2.h.

bool Skype::GetPreviewVideo | ( | const Video::MEDIATYPE & | type,
|  | VideoRef & | video,
|  | const Sid::String | deviceName = `""`,
|  | const Sid::String | devicePath = `""` |
| ) |  |  |

Parameters:

  | deviceName | name and path to be used only with media type VIDEO

bool Skype::GetSpeakerVolume | ( | uint & | volume | ) |

Returns value of audio playback volume setting (0..100).

bool Skype::GetStr | ( | const Sid::String & | key,
|  | Sid::String & | value |
| ) |  |  |

This is used for retrieving local setup keys of type string. For more information, see Defines section in the skype-embedded_2.h

bool Skype::GetSubKeys | ( | const Sid::String & | key,
|  | Sid::List_String & | value |
| ) |  |  |

bool Skype::GetSuggestedSkypename | ( | const Sid::String & | fullname,
|  | Sid::String & | suggestedName |
| ) |  |  |

suggest a nice skypename to go with given fullname

bool Skype::GetVersionString | ( | Sid::String & | version | ) |

returns the runtime version as a string

bool Skype::HasVideoDeviceCapability | ( | const Sid::String & | deviceName,
|  | const Sid::String & | devicePath,
|  | const Video::VIDEO_DEVICE_CAPABILITY & | cap |
| ) |  |  |

Queries whether the given video device has a specific Video::VIDEO_DEVICE_CAPABILITY. Use Skype::GetAvailableVideoDevices method to retrieve sstring lists with available deviceName and devicePath values.

Parameters:

  | deviceName | Human readable device name.
  | devicePath | Device ID.
  | cap | Any of the Video::VIDEO_DEVICE_CAPABILITY values.

bool Skype::IdentitiesMatch | ( | const Sid::String & | identityA,
|  | const Sid::String & | identityB,
|  | bool & | result |
| ) |  |  |

compares two identities to see if they match

static Skype* Skype::instance | ( |  | ) | `[inline, static]`

Definition at line 3076 of file skype-embedded_2.h.

bool Skype::IsDefined | ( | const Sid::String & | key,
|  | bool & | value |
| ) |  |  |

Returns true if the given setup key is defined in local setup. For more information, see Defines section in the skype-embedded_2.h

bool Skype::IsMicrophoneMuted | ( | bool & | muted | ) |

Returns true in &muted argument if the currently selected microphone is muted.

bool Skype::IsSpeakerMuted | ( | bool & | muted | ) |

Returns true in &muted argument if the currently selected playback device is muted.

const unsigned int Skype::moduleID | ( |  | ) | const

Definition at line 5 of file skype-embedded_2.cpp.

bool Skype::MuteMicrophone | ( | const bool & | mute | ) |

Sets currently selected microphone mute status according to argument.

bool Skype::MuteSpeakers | ( | const bool & | mute | ) |

Sets currently selected playback device mute status according to argument.

Account * Skype::newAccount | ( | int | oid | ) | `[protected, virtual]`

Examples:
  tutorial_1.cpp, tutorial_3.cpp, and tutorial_9.cpp.

Definition at line 1904 of file skype-embedded_2.cpp.

References Account.

Contact * Skype::newContact | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1859 of file skype-embedded_2.cpp.

References Contact.

ContactGroup * Skype::newContactGroup | ( | int | oid | ) | `[protected, virtual]`

Examples:
  tutorial_9.cpp.

Definition at line 1854 of file skype-embedded_2.cpp.

References ContactGroup.

ContactSearch * Skype::newContactSearch | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1864 of file skype-embedded_2.cpp.

References ContactSearch.

Conversation * Skype::newConversation | ( | int | oid | ) | `[protected, virtual]`

Examples:
  tutorial_3.cpp.

Definition at line 1874 of file skype-embedded_2.cpp.

References Conversation.

Message * Skype::newMessage | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1879 of file skype-embedded_2.cpp.

References Message.

Participant * Skype::newParticipant | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1869 of file skype-embedded_2.cpp.

References Participant.

Sms * Skype::newSms | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1894 of file skype-embedded_2.cpp.

References Sms.

Transfer * Skype::newTransfer | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1899 of file skype-embedded_2.cpp.

References Transfer.

Video * Skype::newVideo | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1884 of file skype-embedded_2.cpp.

References Video.

Voicemail * Skype::newVoicemail | ( | int | oid | ) | `[protected, virtual]`

Definition at line 1889 of file skype-embedded_2.cpp.

References Voicemail.

bool Skype::NormalizeIdentity | ( | const Sid::String & | original,
|  | NORMALIZERESULT & | result,
|  | Sid::String & | normalized,
|  | const bool | isNewSkypeName = `false` |
| ) |  |  |

This method is deprecated. Use ValidateProfileString method instead.

bool Skype::NormalizePSTNWithCountry | ( | const Sid::String & | original,
|  | NORMALIZERESULT & | result,
|  | Sid::String & | normalized,
|  | const uint | countryPrefix = `0` |
| ) |  |  |

NormalizePSTNWithCountry checks if the phone number starts with + if it doesn't, it prefixes the output with +XXX (where XXX is the country code). It also converts letters to numbers based on the standard phone keypad, so that the phone number string 212CALLME1 with country code 372 (Estonia) would be normalized to +3722122255631. If the method cannot normalize the phone number (because it's too long, too short, etc.), it returns an error code in &result.

virtual void Skype::OnApp2AppDatagram | ( | const Sid::String & | appname,
|  | const Sid::String & | stream,
|  | const Sid::Binary & | data |
| ) |  |  | `[virtual]`

This event gets fired on incoming app2app datagram.

Parameters:

  | appname | App2app application ID.
  | stream | App2app stream ID - see OnApp2AppStreamListChange event for obtaining stream IDs.
  | data | Datagram payload - limited to 1500 bytes.

virtual void Skype::OnApp2AppStreamListChange | ( | const Sid::String & | appname,
|  | const APP2APP_STREAMS & | listType,
|  | const Sid::List_String & | streams,
|  | const Sid::List_uint & | receivedSizes |
| ) |  |  | `[virtual]`

In context of datagrams, this event will fire when:

- Connection is established between two app2app applications. That is, when both parties have an app up with the same name and -both- used App2AppConnect In that case, both parties get this event, with listType ALL_STREAMS
- When a datagram is sent, the sender will get this event with listType SENDING_STREAMS Receiver of the datagram will get OnApp2AppDatagram event instead.
- When the remote party drops app2app connection, the local user will get OnApp2AppStreamListChange with listType ALL_STREAMS and streams.size() zero.
  In context of stream reads/writes, this event will fire for both the sender (listType == SENDING_STREAMS)and the receiver (listType == RECEIVED_STREAMS). For receiver side, this is the place to put your reading code - App2AppRead.
  Parameters:

    | appname | application ID - the name you supplied in App2AppCreate.
    | listType | application list type (read/write/all)
    | streams | SEStringlist with affected stream IDs.
    | receivedSizes | For RECEIVED_STREAMS, contains the number of bytes in each stream waiting to be read

Examples:
  tutorial_11.cpp.

void Skype::OnAvailableDeviceListChange | ( |  | ) | `[virtual]`

This callback gets fired when there are changes in the system audio device list (USB headset gets plugged in or is detached.)

Definition at line 1765 of file skype-embedded_2.cpp.

void Skype::OnAvailableVideoDeviceListChange | ( |  | ) | `[virtual]`

This callback gets fired when there are changes in the system video device list (USB webcam gets plugged in or is detached.)

Definition at line 1722 of file skype-embedded_2.cpp.

virtual void Skype::OnContactGoneOffline | ( | const ContactRef & | contact | ) | `[virtual]`

This contact has gone offline. display alert

virtual void Skype::OnContactOnlineAppearance | ( | const ContactRef & | contact | ) | `[virtual]`

This contact has appeared online. display alert

virtual void Skype::OnConversationListChange | ( | const ConversationRef & | conversation,
|  | const Conversation::LIST_TYPE & | type,
|  | const bool & | added |
| ) |  |  | `[virtual]`

This event gets fired when a Conversation item is added or removed from the list specified in the type argument. The primary use of this event is to detect creation of new Conversation objects. It can also be used for detecting occurance of live sessions - by monitoring added = true in Conversation::LIVE_CONVERSATIONS. Note that this method is not entirely sufficient for detecting live session termination (added = false and type = Conversation::LIVE_CONVERSATIONS). When the live session goes down, the default behaviour is that the Conversation object remains in the LIVE_CONVERSATIONS list for approximately 10 seconds. When another live session comes up within the same Conversation, the OnConversationListChange event will not fire - because the conversation was already in that list. There are two ways of getting around that. Firstly you can have all the conversations referenced at all times and then monitor Conversation::P_LOCAL_LIVESTATUS property changes, in which case you can pick up incoming live sessions from there. Alternatively, you can remove the delay between live session termination and conversation's removal from the LIVE_CONVERSATIONS list. This delay is controlled by the SETUPKEY_RECENTLY_LIVE_TIMEOUT setup key. To remove the delay, use Skype::SetInt(SETUPKEY_RECENTLY_LIVE_TIMEOUT, 0). Note that this setup key is account-based. You will need to have an account logged in in order to modify its value.

Parameters:

  | conversation | Conversation object that was added or removed to a list specified in the type argument.
  | type | Specifies the list, into which the conversation was added or removed from.
  | added | Specifies whether the conversation was added or removed. For ALL_CONVERSATIONS list, the removed event is only fired when the conversation is actually deleted.

Examples:
  tutorial_14.cpp, tutorial_16.cpp, tutorial_3.cpp, and tutorial_5.cpp.

virtual void Skype::OnMessage | ( | const MessageRef & | message,
|  | const bool & | changesInboxTimestamp,
|  | const MessageRef & | supersedesHistoryMessage,
|  | const ConversationRef & | conversation |
| ) |  |  | `[virtual]`

Parameters:

  | changesInboxTimestamp | if changesInboxTimestamp==true is a hint that tray alert should probably be displayed
  | supersedesHistoryMessage | DEPRECATED, not set anymore

virtual void Skype::OnNewCustomContactGroup | ( | const ContactGroupRef & | group | ) | `[virtual]`

Parameters:

  | group | eg, new contact group loaded from CBL

void Skype::OnNrgLevelsChange | ( |  | ) | `[virtual]`

This callback gets fired when the audio strength changes in either playback or recording audio streams. Useful for providing visual indicators of audio activity in your UI.

Definition at line 1768 of file skype-embedded_2.cpp.

virtual void Skype::OnProxyAuthFailure | ( | const PROXYTYPE & | type | ) | `[virtual]`

bool Skype::PlayStart | ( | const uint & | soundid,
|  | const Sid::Binary & | sound,
|  | const bool & | loop,
|  | const bool | useCallOutDevice = `false` |
| ) |  |  |

Takes audio data that comes from the sound argument and mixes it into playback or notification device, depending on the value passed in the useCallOutDevice argument. The sound argument contains the audio data in in follwing format: first 4 bytes of the binary contain the sample rate, followed by 16 bit (mono) samples. The soundid argument is an arbitrary ID that you can pass in and then later use as an argument for Skype class PlayStop method. To mix the audio into playback device stream, set useCallOutDevice to true, to mic it into notification stream, set useCallOutDevice to false.

bool Skype::PlayStartFromFile | ( | const uint & | soundid,
|  | const Sid::Filename & | datafile,
|  | const bool & | loop,
|  | PREPARESOUNDRESULT & | result,
|  | const bool | useCallOutDevice = `false` |
| ) |  |  |

bool Skype::PlayStop | ( | const uint & | soundid | ) |

Stops playback of the soundfile. The argument is the same ID you passed in the Skype class StartPlayback method.

Sid::List_uint * Skype::prop_cached_list | ( | void * | propstruct,
|  | const uint & | moduleid |
| ) |  |  |

Definition at line 1951 of file skype-embedded_2.cpp.

References Account::MODULE_ID, Transfer::MODULE_ID, Sms::MODULE_ID, Voicemail::MODULE_ID, Video::MODULE_ID, Message::MODULE_ID, Conversation::MODULE_ID, Participant::MODULE_ID, ContactSearch::MODULE_ID, Contact::MODULE_ID, and ContactGroup::MODULE_ID.

void * Skype::prop_factory | ( | const uint & | moduleid | ) |

Definition at line 1982 of file skype-embedded_2.cpp.

References Account::MODULE_ID, Transfer::MODULE_ID, Sms::MODULE_ID, Voicemail::MODULE_ID, Video::MODULE_ID, Message::MODULE_ID, Conversation::MODULE_ID, Participant::MODULE_ID, ContactSearch::MODULE_ID, Contact::MODULE_ID, and ContactGroup::MODULE_ID.

bool Skype::RequestConfirmationCode | ( | const Sms::CONFIRM_TYPE & | type,
|  | const Sid::String & | number,
|  | SmsRef & | sms |
| ) |  |  |

creates an CONFIRMATION_CODE_REQUEST SMS message

bool Skype::SelectSoundDevices | ( | const Sid::String & | callInDevice,
|  | const Sid::String & | callOutDevice,
|  | const Sid::String & | waveOutDevice |
| ) |  |  |

Sets audio devices given in arguments as active audio devices. This command selects all three devices - microphone, playback and the notification channel. Valid input values for this method come from the first string list you get back from Skype class GetAvailableOutputDevices (handleList).

bool Skype::SetBin | ( | const Sid::String & | key,
|  | const Sid::Binary & | value |
| ) |  |  |

This is used for setting local setup keys of type binary. For more information, see Defines section in the skype-embedded_2.h

bool Skype::SetInt | ( | const Sid::String & | key,
|  | const int & | value |
| ) |  |  |

This is used for setting local setup keys of type int. For more information, see Defines section in the skype-embedded_2.h

bool Skype::SetMicVolume | ( | const uint & | volume | ) |

This method is for setting the microphone volume level. This does not work when Skype AGC (Automatic Gain Control) is enabled, which it is by default. It is currently impossible to disable AGC, so for now this method is here for purpose of future compatibility.

bool Skype::SetOperatingMedia | ( | const OPERATING_MEDIA & | media,
|  | const uint & | maxUplinkBps,
|  | const uint & | maxDownlinkBps |
| ) |  |  |

bool Skype::SetSpeakerVolume | ( | const uint & | volume | ) |

This method is for setting speaker volume. It will set the level for Skype digital gain control. Skype audio library will not control gain of audio device itself.

bool Skype::SetStr | ( | const Sid::String & | key,
|  | const Sid::String & | value |
| ) |  |  |

This is used for setting local setup keys of type string. For more information, see Defines section in the skype-embedded_2.h

bool Skype::Start | ( | bool & | started | ) |

bool Skype::start | ( |  | ) |

Definition at line 2012 of file skype-embedded_2.cpp.

References Start().

bool Skype::StartRecordingTest | ( | const bool | recordAndPlaybackData = `false` | ) |

bool Skype::StopRecordingTest | ( |  | ) |

bool Skype::SubmitConfirmationCode | ( | const Sid::String & | number,
|  | const Sid::String & | code,
|  | SmsRef & | sms |
| ) |  |  |

creates an CONFIRMATION_CODE_REQUEST SMS message

bool Skype::ValidateAvatar | ( | const Sid::Binary & | value,
|  | VALIDATERESULT & | result,
|  | int & | freeBytesLeft |
| ) |  |  |

bool Skype::ValidatePassword | ( | const Sid::String & | username,
|  | const Sid::String & | password,
|  | VALIDATERESULT & | result |
| ) |  |  |

This method is for pre-validating account passwords before account creation or password change. The result will return either VALIDATED_OK or one of many possible reasons the password is unacceptable (too short, too simple, etc.)

bool Skype::ValidateProfileString | ( | const int & | propKey,
|  | const Sid::String & | strValue,
|  | VALIDATERESULT & | result,
|  | int & | freeBytesLeft,
|  | const bool | forRegistration = `false` |
| ) |  |  |

This method should be used for validating skypenames before registering new accounts, if the propKey is set to SKYPENAME (Contact class) and forRegistration argument is set to true. If the forRegistration argument is false, only string length check is applied. It is also useful to probe, what the size limits are, for each string property (e.g. 300 characters for moodmessage)

bool Skype::VideoCommand | ( | const Sid::String & | command,
|  | Sid::String & | response |
| ) |  |  |

Avaible to Video Engines using the Video RTP API

bool Skype::VoiceCommand | ( | const Sid::String & | command,
|  | Sid::String & | response |
| ) |  |  |

NB! This command only works if its implemented in external audiohost (RTP or PCM host). The command can be is used for passing custom commands from client UI to the audio implementation.

## Friends And Related Function Documentation

friend class Account`[friend]`

Definition at line 3053 of file skype-embedded_2.h.

friend class Contact`[friend]`

Definition at line 3044 of file skype-embedded_2.h.

friend class ContactGroup`[friend]`

Definition at line 3043 of file skype-embedded_2.h.

friend class ContactSearch`[friend]`

Definition at line 3045 of file skype-embedded_2.h.

friend class Conversation`[friend]`

Definition at line 3047 of file skype-embedded_2.h.

friend class Message`[friend]`

Definition at line 3048 of file skype-embedded_2.h.

friend class Participant`[friend]`

Definition at line 3046 of file skype-embedded_2.h.

friend class SEObject`[friend]`

Definition at line 3042 of file skype-embedded_2.h.

friend class Sms`[friend]`

Definition at line 3051 of file skype-embedded_2.h.

friend class Transfer`[friend]`

Definition at line 3052 of file skype-embedded_2.h.

friend class Video`[friend]`

Definition at line 3049 of file skype-embedded_2.h.

friend class Voicemail`[friend]`

Definition at line 3050 of file skype-embedded_2.h.

The documentation for this class was generated from the following files:

- skype-embedded_2.h
- skype-embedded_2.cpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines

(c) Skype Technologies S.A. Confidential/Proprietary

Last updated: Fri Mar 16 2012